----------------------------------------------------------------------------------------------------------------
-- Written in LUA by JeroenZeist (https://www.domoticz.com/forum/memberlist.php?mode=viewprofile&u=6788)
-- Summer 2015
-- 26-08-2015 v1.0 Initial release
-- script_device_intergasincomfort.lua
-- Requires:
-- - Intergas Incomfort Gateway
-- - Virtual devices in Domoticz:
 -- - Temperature sensor for current temperature
 -- - Temperature sensor for current temperature setpoint
 -- - Virtual thermostat for temperature setpoint
----------------------------------------------------------------------------------------------------------------

-- config ------------------------------------------------------------------------------------------------------
local debug = true -- false or true, true gives extra output in Domoticz log
lan2rf = '192.168.1.206' -- ip address of the Intergas Incomfort Lan2RF gateway
tempfilename = '/var/tmp/thermostat.tmp' -- could be anywhere as long as it is writeable

local idxt = 32 --idx of the virtual temperature sensor you need to change this to your own Device IDx
local currenttempname = "Woonkamer huidig" -- name of the virtual temperature sensor

local idxset = 33 -- idx for set temperature on the physical thermostat
local currentlyset = "Woonkamer ingesteld" -- name of the virtual set temperature on the physical thermostat

local idxsetthermostat = 34 -- idx of the virtual thermostat in Domoticz
local thermostatname = "Thermostaat" -- name of the virtual thermostat in Domoticz

-- Functions ---------------------------------------------------------------------------------------------------
function UpdateVirtualThermostat()
	if otherdevices_svalues[thermostatname] + 0.01 ~= otherdevices_svalues[currentlyset] + 0.01 then
		if debug then print ("Difference between Virtual thermostat and set temp") end
		if otherdevices_lastupdate[currentlyset] > otherdevices_lastupdate[thermostatname] then
			if debug then print("Lastupdated temperature is later then virtual thermostat setpoint") end
			commandArray[4] = {['OpenURL']='http://192.168.1.201:8084/json.htm?param=udevice&type=command&idx='..idxsetthermostat..'&nvalue=0&svalue='..otherdevices_svalues[currentlyset]}
		elseif otherdevices_lastupdate[thermostatname] > otherdevices_lastupdate[currentlyset] then
			if debug then print("Virtual thermostat is updated later then physical thermostat") end
			SetTemperature(otherdevices_svalues[thermostatname])
		end
	end
end

function SetTemperature(tosettemp)
	local test = false
	local tosettempcalc = (tosettemp-5.0)*10
	if debug then print("Calculated value to set temperature (used by lan2rf gateway): "..tosettempcalc) end
	url='http://'..lan2rf..'/data.json?heater=0&setpoint='..tosettempcalc..'&thermostat=0×'
	if debug then print("URL to change temperature setpoint: "..url) end
	if debug then print("Test thermostat setpoint: "..tosettemp) end
	commandArray[5] = {['OpenURL']=url}
end

-- Incomfort -----------------------------------------------------------------------------------------------------
commandArray = {}
UpdateVirtualThermostat()
return commandArray 